.set		ALIGN, 1 << 0
.set		MEMINFO, 1 << 1
.set		FLAGS, ALIGN | MEMINFO
.set		MAGIC, 0x1BADB002	# ???
.set		CHECKSUM, -(MAGIC + FLAGS)

.section	.multiboot
.align		4
.long		MAGIC
.long		FLAGS
.long		CHECKSUM

.section	.bss
.align		16
stack_bottom:
.skip		16384	# Pile de 16KiB
stack_top: 

.section	.text
.global		_start
.type		_start, @function
_start:
# On peut initialiser des trucs très bas niveau ici
	mov		$stack_top, %esp

# Chargement du GDT
	call	create_gdt
	call	load_gdt

# Chargement de tout ce qui touche aux interrupt
	call	create_idt
	call	load_idt

	call	hardware_init
	call	PIC_init

# Trucs de plus haut niveau
	sti
	call	_init
	call	kernel_main

# Boucle infinie, pas censé arriver à la fin
main_loop:
	hlt
	jmp		main_loop

.size		_start, . - _start
