/*
Le PIT contient un oscillateur avec une fréquence de base de 1193.182Hz. Il y a
trois horloges différentes, qui servent plusieurs fonctions :
	- 0x40 : horloge reliée à IRQ0
	- 0x41 : obsolète
	- 0x42 : générateur de fréquences pour le haut-parleur

En outre, un registre de commande à 0x43 peut être écrit pour programmer chaque
horloge.
*/

#ifndef PIT_H
#define PIT_H

#include <kernel/timer.h>

#ifdef __arch_i386__
#define PIT_OUT 0x40
#define PIT_CMD_REG 0x43
#endif

#define BASE_FREQ 1193182

typedef enum _pit_mode
{
	PIT_ONESHOT,
	PIT_ONESHOT_HARDWARE,
	PIT_REPEAT,
	PIT_SQUARE,
	PIT_STROBE,
	PIT_STROBE_HARDWARE
} pit_mode;

typedef enum _pit_access
{
	PIT_ACC_LOW = 1,
	PIT_ACC_HIGH,
	PIT_ACC_WHOLE
} pit_access;

#define PIT_CHANNELS 3
typedef enum _pit_channel
{
	PIT_IRQ = 0,
	PIT_SPK = 2
} pit_channel;

#endif
